﻿using System.Threading;
using System.Windows;

namespace HighVoltz.HBRelog.WebServer
{
    class HBWebServer //singleton
    {
        private static readonly HBWebServer instance = new HBWebServer();
        private static Thread _webServerThread;
        private static HttpServer httpServer;
        
        private HBWebServer() { }

        public static HBWebServer Instance
        {
            get 
            {
                return instance; 
            }
        }

        public static void StartWebServer(int port, bool refreshTmpPngOnRequest)
        {
            httpServer = new WebServerRequestHandle(port, refreshTmpPngOnRequest);
            _webServerThread = new Thread(new ThreadStart(httpServer.listen));
            _webServerThread.Start();
        }

        public static void StartWebServer(int port)
        {
            httpServer = new WebServerRequestHandle(port);
            _webServerThread = new Thread(new ThreadStart(httpServer.listen));
            _webServerThread.Start();
        }
        
        public static void ShutdownWebServer()
        {
            httpServer.finish();
        }
    }
}
