﻿using System.IO;
using System.Net.Sockets;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;

namespace HighVoltz.HBRelog.WebServer
{
    public abstract class HttpServer
    {
        protected int port;
        TcpListener listener;
        public bool is_active = true;

        public HttpServer(int port)
        {
            this.port = port;
            
        }

        public void listen()
        {
            listener = new TcpListener(port);
            listener.Start();
            try
            {
                while (is_active)
                {
                    TcpClient s = listener.AcceptTcpClient();
                    HttpProcessor processor = new HttpProcessor(s, this);
                    Thread thread = new Thread(new ThreadStart(processor.process));
                    thread.Start();
                    Thread.Sleep(1);
                }
            }
            catch
            {
            }
        }

        public void finish()
        {
            is_active = false;
            listener.Stop();
        }


        public abstract void handleGETRequest(HttpProcessor p);
        public abstract void handlePOSTRequest(HttpProcessor p, StreamReader inputData);
    }

}
